# BoobyLegends Economic Helper

This is intended as a helper to find trends in the Booby Legends game.

I intend to built a [Discord Bot Interface](DiscordBot.md) to let us share in our guild.

## Running Executables

### Gather Marketing Data
This will gather marketing data every 15 minutes, and build an average for each day in UTC timezone.
```bash
python3 gatherMarket.py
```
 
## Classes

There are some main components written as python classes.

### Market
Loads the current Market values for cards.

You can initialize the Market List like this:
```python
from market import Market
m=Market()
m.fetchData()
m.show()
```
Show a filtered Market Page with cards you alreqady have Crystalized removed.
```python
from market import Market
m=Market()
m.fetchData()
m.filterMarketCards(False)
#After doing stuff...
m.closePage()
```

### Player
Loads the current Player values for cards.
To get stock values, a "config.json" file must be in the folder with a "cookie" defined to have the player's login.  I got my cookie by using the "EditThisCookie" plugin for Chrome.  The config file should looks omething like this.
```json
{
    "cookie":
        {
            "name":"wordpress_logged_in_f129834928365fbaer348384348y23423uy2323",
            "value":"keymasterofgozer%8ksojhelFM88efn98709cvaSneOVWEUVn9dvs9eVASEvjSEv8ksojhelFM88efn98709cvaSneOVWEUVn9dvs9eVASEvjSEv8ksojhelFM88efn98709cvaSneOVW"
        }
}
```

You can initialize your Player list like this:
```python
from player import Player
p=Player()
p.fetchData()
p.show()
```

Get a List of non-crystal remaining Cards to collect
```python
from player import Player
p=Player()
p.fetchData()
p.show(fields=['name','level','stock'],filter='stock != "CRYSTAL"')
```


### Market Data
```python
from db import MarketDB, hist, plot
hist(2)
plot(2)
```

### Get javascript to filter Market
```python
from datetime import datetime
from db import PlayerDB
from tinydb import Query
import json
today=datetime.utcnow().strftime('%Y-%m-%d')
Cards=PlayerDB.search(Query().fragment({'date':today}))
clist=[None]*152
for card in Cards: clist[card['card-num']]=card['stock']

js="clist={clist}\n".format(clist=json.dumps(clist))
js+="""
cards=document.getElementsByClassName('wrapper-market-card')
for (var i = 0; i < cards.length; i++) {
    cardNum = cards.item(i).getElementsByClassName('pornstar-number')[0].outerText;
    innerCard = cards.item(i).getElementsByClassName('inner-market-card')[0]
    var stock = innerCard.getElementsByClassName('Stock')[0]
    if (stock){stock.innerText = "Stock: " + clist[cardNum]}
    else {
        let qty = document.createElement('div');
        qty.classList.add('Stock')
        qty.innerText = "Stock: " + clist[cardNum]
        innerCard.appendChild(qty)
        }
    if (clist[cardNum].includes('CRYSTAL')){
        cards.item(i).style.setProperty('Display','None');
    }
}"""
print(js)
```
